# [v2.0.2-2020/03/08 Knife4j 2.0.2发布,Swagger接口文档赋能工具]

`Knife4j`前身是`swagger-bootstrap-ui`,是一个为Swagger接口文档赋能的工具

**文档**：[https://doc.xiaominfo.com](https://doc.xiaominfo.com/)

**效果(旧版)**:http://swagger-bootstrap-ui.xiaominfo.com/doc.html

**效果(2.X版)**：[http://knife4j.xiaominfo.com/doc.html](http://knife4j.xiaominfo.com/doc.html)

**Gitee**：https://gitee.com/xiaoym/knife4j

**GitHub**：https://github.com/xiaoymin/swagger-bootstrap-ui

**示例**：https://gitee.com/xiaoym/swagger-bootstrap-ui-demo

## 特性 & 优化

### knife4j

1、新增`knife4j-dependencies`模块,管理knife4j的相关Maven引用,可以以Maven的BOM方式引入`Knife4j`

2、[官网](http://doc.xiaominfo.com/)文档同步更新.

3、解决`swagger-annotations`导致的版本冲突[gitee #I17G31](https://gitee.com/xiaoym/knife4j/issues/I17G31)、[GitHub #191](https://github.com/xiaoymin/swagger-bootstrap-ui/issues/191)

### knife4j-spring-ui

1、修复切换tab之后 再次发送请求不带参数且不显示响应数据的问题，调试异常等问题[PR 13 @gitee](https://gitee.com/xiaoym/knife4j/pulls/13)、[gitee #I17FFX](https://gitee.com/xiaoym/knife4j/issues/I17FFX)、[GitHub #196](https://github.com/xiaoymin/swagger-bootstrap-ui/issues/196)、[GitHub #187](https://github.com/xiaoymin/swagger-bootstrap-ui/issues/187)

2、优化调试框全部选中的问题,在取消全选时,只有在输入参数改变时才会选中该参数,取消原来默认选中全部参数[gitee #I19V6D](https://gitee.com/xiaoym/knife4j/issues/I19V6D)

3、针对Form表单类型的请求构造curl命令行时在未输入值的情况下为null的情况,修改为空字符串[gitee #I18IBZ](https://gitee.com/xiaoym/knife4j/issues/I18IBZ)

4、优化全局参数设置功能,针对参数数据太长不换行问题，以及参数需要修改时需要重新删除的交互体验，开发者在新增参数后可以方便的更改参数数据值以及参数的类型[gitee #I17OV1](https://gitee.com/xiaoym/knife4j/issues/I17OV1)、[gitee #I19GJK](https://gitee.com/xiaoym/knife4j/issues/I19GJK)、[gitee #I1A9V1](https://gitee.com/xiaoym/knife4j/issues/I1A9V1)、[gitee #I18HMJ](https://gitee.com/xiaoym/knife4j/issues/I18HMJ)、[GitHub #176](https://github.com/xiaoymin/swagger-bootstrap-ui/issues/176)

5、请求参数在未给定example默认值的情况下,文本输入框的placeHolder属性显示该字段的文字说明[gitee #I17RKI](https://gitee.com/xiaoym/knife4j/issues/I17RKI)

6、修复增强属性忽略参数不生效的问题[gitee #PR-16](https://gitee.com/xiaoym/knife4j/pulls/16)、[gitee #I136KU](https://gitee.com/xiaoym/knife4j/issues/I136KU)、[gitee #I187VN](https://gitee.com/xiaoym/knife4j/issues/I187VN)、[gitee #I16A71](https://gitee.com/xiaoym/knife4j/issues/I16A71)

7、调试参数框增加对后端枚举的支持,改输入框为下拉选择框[gitee #I18MHO](https://gitee.com/xiaoym/knife4j/issues/I18MHO)

![](/knife4j/images/blog/knife4j2.0.2/debug-2.png)

8、service-worker.js报404问题，构建打包时添加此文件[gitee #I17D0Y](https://gitee.com/xiaoym/knife4j/issues/I17D0Y)、[GitHub #185](https://github.com/xiaoymin/swagger-bootstrap-ui/issues/185)

9、get请求参数出现特殊字符未编码处理导致出现400错误[gitee #I19C8Y](https://gitee.com/xiaoym/knife4j/issues/I19C8Y)

10、后端新增接口或者接口编辑后,在ui界面显示更新标志,在菜单上会出现一个蓝色的徽标[gitee #I1AQFW](https://gitee.com/xiaoym/knife4j/issues/I1AQFW)，如下图:

![](/knife4j/images/blog/knife4j2.0.2/debug-1.png)

11、后端增强注解`@ApiOperationSupport(author = "xiaoymin@foxmail.com")`支持每个接口提供开发者的呈现,最终如下图：

![](/knife4j/images/blog/knife4j2.0.2/debug-3.png)

12、调试发送按钮增加`loading`效果,针对接口响应较长的情况下提升交互效果

13、针对Authorize菜单栏的参数,保存参数是全局保存,其它逻辑分组的接口再调试时,不需要再保存一次新值[gitee #I16Z10](https://gitee.com/xiaoym/knife4j/issues/I16Z10)

14、修复部分情况响应字段在ace-editor编辑器右边栏不显示字段说明的情况[gitee #I17F5Y](https://gitee.com/xiaoym/knife4j/issues/I17F5Y)

15、搜索框完善对接口请求Api地址栏的模糊搜索匹配[gitee #I19EN0](https://gitee.com/xiaoym/knife4j/issues/I19EN0)、[gitee #I1B0Q9](https://gitee.com/xiaoym/knife4j/issues/I1B0Q9)

16、调试响应数据行太长,无法换行的问题[gitee #I17F1J](https://gitee.com/xiaoym/knife4j/issues/I17F1J)

17、在当前接口无参数的情况下,界面添加全局参数无效果的bug

如果你后端是Java+Spring的技术栈，在使用springfox的同时，想换一个Swagger的Ui皮肤，通过在pom.xml中直接引入即可,如下：

```xml
<dependency>
  <groupId>com.github.xiaoymin</groupId>
  <artifactId>knife4j-spring-ui</artifactId>
  <version>2.0.2</version>
</dependency>
```

### Knife4j-Spring

使用Spring Boot的技术栈可以通过引用starter的方式快速引入使用,注意该starter组件是包含Ui的,如下：

```xml
<dependency>
  <groupId>com.github.xiaoymin</groupId>
  <artifactId>knife4j-spring-boot-starter</artifactId>
  <version>2.0.2</version>
</dependency>
```

如果是微服务的情况下,微服务其实不需要引用Ui的jar包，只需要在网关引用Ui的jar包依赖,所以在微服务情况下,使用增强属性只需要引用微服务版本的starter依赖,如下：

```xml
<dependency>
    <groupId>com.github.xiaoymin</groupId>
    <artifactId>knife4j-micro-spring-boot-starter</artifactId>
    <version>2.0.2</version>
</dependency>

```

## 特点

- 基于Vue+Ant Design构建的文档，更强大、清晰的接口文档说明能力以及接口调试能力
- 左右布局,基于Tabs组件的多文档查阅风格
- 支持在线导出Html、Markdown、Word、PDF等多种格式的离线文档
- 接口排序,支持分组及接口的排序功能
- 支持接口全局在线搜索功能
- 提供Swagger资源保护策略,保护文档安全
- 接口调试支持无限参数,开发者调试非常灵活，动态增加、删除参数
- 全局缓存调试信息,页面刷新后依然存在,方便开发者调试
- 以更人性化的table树组件展示Swagger Models功能
- 文档以多tab方式可显示多个接口文档
- 请求参数栏请求类型、是否必填着颜色区分
- 主页中粗略统计接口不同类型数量
- 支持自定义全局参数功能，主页包括header及query两种类型
- JSR-303 annotations 注解的支持
- 更多个性化设置功能

## 界面

接口文档显示界面如下：

![](/knife4j/images/blog/knife4j2.0.2/1.png)

接口调试界面如下：

![](/knife4j/images/blog/knife4j2.0.2/8.png)

Swagger Models功能

![](/knife4j/images/blog/knife4j2.0.2/6.png)

![](/knife4j/images/blog/knife4j2.0.2/7.png)

支持导出离线Markdown、Html功能，markdown的表格较原先版本通过缩减显示为树形结构,[点击预览导出离线Html效果](https://doc.xiaominfo.com/html/knife4j-export-html.html)，效果图如下：

![](/knife4j/images/blog/knife4j2.0.2/3.png)

通过第三方Markdown软件导出的PDF效果如下图:

![](/knife4j/images/blog/knife4j2.0.2/4.png)

同时提供了导出离线Html功能,Html功能界面风格和在线几乎没有区别,美观、大方、简洁,[点击在线预览效果](https://doc.xiaominfo.com/Knife4j-Offline-Html.html)，

界面效果如下图：

![](/knife4j/images/blog/knife4j2.0.2/5.png)

## Star & Issue

感谢各位朋友的支持,前往[https://gitee.com/xiaoym/knife4j](https://gitee.com/xiaoym/knife4j)点个Star吧~~ ：）

 
 
 